#include <stdio.h>
#include <stdlib.h>
#include <zlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>

int main(int argc, char **argv)
{
    unsigned char *dest;
    long int len = 65000;
    unsigned char *src;
    int i;
    int fd;
    struct stat st;

    dest = (char *)malloc(65000);
    
    /* prepare manual html stream */
    fd = open("../doc/manual.html", O_RDONLY);
    fstat(fd, &st);
    src = (char *)mmap(NULL, st.st_size, PROT_READ, MAP_SHARED, fd, 0);
    compress2(dest, &len, src, strlen(src), 9);

    printf("#ifndef _HTML_H_\n#define _HTML_H_\n\n");
    printf("/* manual html stream */\n");
    printf("#define MANUAL_CLEN %ld\n", len);
    printf("#define MANUAL_LEN %ld\n", st.st_size);
    printf("static char *manual_stream = \n\"");
    for (i = 0; i < len; i++) {
	printf("\\x%02x", dest[i]);
	if ((i % 19) == 18)
	    printf("\"\n\"");
    }
    printf("\";\n\n");
    munmap((void *)src, st.st_size);
    close(fd);

    /* prepare about stream */
    len = 65000;
    memset(dest, 0, 65000);
    fd = open("../doc/about.html", O_RDONLY);
    fstat(fd, &st);
    src = (char *)mmap(NULL, st.st_size, PROT_READ, MAP_SHARED, fd, 0);
    compress2(dest, &len, src, strlen(src), 9);

    printf("/* about html stream */\n");
    printf("#define ABOUT_CLEN %ld\n", len);
    printf("#define ABOUT_LEN %ld\n", st.st_size);
    printf("static char *about_stream = \n\"");
    for (i = 0; i < len; i++) {
	printf("\\x%02x", dest[i]);
	if ((i % 19) == 18)
	    printf("\"\n\"");
    }
    printf("\";\n\n");
    printf("#endif /* _HTML_H_ */\n");
    munmap((void *)src, st.st_size);
    close(fd);

    return 0;
}
